diff --git a/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java b/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
new file mode 100644
index 000000000..dd643a210
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/motion/CarriedBlock.java
@@ -0,0 +1,137 @@
+package net.minecraft.core.block.motion;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.BlockEntityDispatcher;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public class CarriedBlock implements ICarriable {
+    public int blockId;
+    public int metadata;
+    public @Nullable BlockEntity entity;
+    // Ignore warnings, nbt read process *should* guarantee these to be non-null
+    public @NotNull Entity holder;
+    public @NotNull World world;
+    public CarriedBlock(@NotNull Entity holder, @NotNull Block block, int metadata, @Nullable BlockEntity entity) {
+        this(holder, block.id, metadata, entity);
+    }
+
+    public CarriedBlock(@NotNull Entity holder, int blockId, int metadata, @Nullable BlockEntity entity) {
+        this.holder = holder;
+        this.blockId = blockId;
+        this.metadata = metadata;
+        this.entity = entity;
+        this.world = holder.world;
+    }
+
+    protected CarriedBlock() {
+
+    }
+
+    public Block block() {
+        return Block.getBlock(blockId);
+    }
+
+    @Override
+    public void heldTick(World world, Entity holder) {
+        if (entity != null) {
+            entity.heldTick(world, holder);
+        }
+    }
+
+    @Override
+    public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        if (entity != null) {
+            return entity.tryPlace(world, holder, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+        } else {
+            int x = blockX + side.getOffsetX();
+            int y = blockY + side.getOffsetY();
+            int z = blockZ + side.getOffsetZ();
+
+            Block currentBlock = world.getBlock(x, y, z);
+            if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
+            world.setBlockAndMetadataWithNotify(x, y, z, blockId, metadata);
+
+            Block b = world.getBlock(x, y, z);
+            if (b != null && holder instanceof Mob) {
+                b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, yPlaced);
+            }
+            return true;
+        }
+    }
+
+    @Override
+    public void drop(World world, Entity holder) {
+        if (entity != null) {
+            entity.drop(world, holder);
+        } else {
+            final int holderX = MathHelper.floor(holder.x);
+            final int holderY = MathHelper.floor(holder.y);
+            final int holderZ = MathHelper.floor(holder.z);
+            for (int _y = holderY - 1; _y <= holderY + 1; _y++) {
+                for (int _x = holderX - 1; _x <= holderX + 1; _x++) {
+                    for (int _z = holderZ - 1; _z <= holderZ + 1; _z++) {
+                        if (tryPlace(world, holder, _x, _y - 1, _z, Side.TOP, 0, 0)) {
+                            return;
+                        }
+                    }
+                }
+            }
+            if (world.isClientSide) return;
+            block().dropBlockWithCause(world, EnumDropCause.WORLD, holderX, holderY, holderZ, metadata, entity, null); // TODO this might be scuffed since the position won't have correlated to a real block
+        }
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
+    @Override
+    public ICarriable pickup(World world, Entity holder) {
+        return this;
+    }
+
+    @Override
+    public void writeToNBT(CompoundTag tag) {
+        if (entity != null) {
+            CompoundTag entityTag = new CompoundTag();
+            entity.writeToNBT(entityTag);
+            tag.put("entity", entityTag);
+        }
+        tag.putInt("block", blockId);
+        tag.putShort("meta", (short) metadata);
+        tag.putString("type", TYPE_BLOCK);
+    }
+
+    @Override
+    public void readFromNBT(CompoundTag tag) {
+        if (tag.containsKey("entity")) {
+            entity = BlockEntityDispatcher.createAndLoadEntity(tag.getCompound("entity"));
+            if (entity != null) {
+                entity.carriedBlock = this;
+            }
+        }
+        blockId = tag.getInteger("block");
+        metadata = tag.getShort("meta");
+    }
+
+    public static CarriedBlock createAndLoadCarriedBlock(@NotNull Entity holder, CompoundTag tag) {
+        CarriedBlock carriedBlock = new CarriedBlock();
+        carriedBlock.holder = holder;
+        carriedBlock.readFromNBT(tag);
+        return carriedBlock;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index 984ff1830..fbe867f72 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.piston;
 
 import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.BlockEntityDispatcher;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Direction;
@@ -46,7 +47,6 @@ public class MovingPistonBlockEntity extends BlockEntity
         return movedId;
     }
 
-    @Override
 	public int getMovedData()
     {
         return movedData;
@@ -188,7 +188,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         movedData = tag.getInteger("blockData");
         if (tag.containsKey("blockEntity")) {
             CompoundTag entityTag = tag.getCompound("blockEntity");
-            movedEntity = BlockEntity.createAndLoadEntity(entityTag);
+            movedEntity = BlockEntityDispatcher.createAndLoadEntity(entityTag);
         }
         direction = Direction.getDirectionById(tag.getInteger("facing"));
         progressO = progress = tag.getFloat("progress");
diff --git a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
index 6b05635c1..125b9c0be 100644
--- a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.FallingBlockEntity;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
@@ -96,13 +97,19 @@ public class SteelPistonBaseBlock extends PistonBaseBlock{
             xo = x + direction.getOffsetX();
             yo = y + direction.getOffsetY();
             zo = z + direction.getOffsetZ();
-            int blockId = world.getBlockId(xo, yo, zo);
+            Block block = world.getBlock(xo, yo, zo);
+            if (block == null) return true;
             int blockMeta = world.getBlockMetadata(xo, yo, zo);
             BlockEntity blockEntity = world.getBlockEntity(xo, yo, zo);
             world.removeBlockTileEntity(xo, yo, zo);
             world.setBlockWithNotify(xo, yo, zo, 0);
-            FallingBlockEntity fallingBlockEntity = new FallingBlockEntity(world, xo + 0.5, yo + 0.5, zo + 0.5, blockId, blockMeta, blockEntity);
+            FallingBlockEntity fallingBlockEntity = new FallingBlockEntity(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id, blockMeta, blockEntity);
             fallingBlockEntity.hasRemovedBlock = true;
+            if (blockEntity instanceof IVehicle) {
+                Entity rider = ((IVehicle) blockEntity).getPassenger();
+                ((IVehicle) blockEntity).ejectRider();
+                if (rider != null) rider.startRiding(fallingBlockEntity);
+            }
             world.entityJoinedWorld(fallingBlockEntity);
         }
         return true;
@@ -113,7 +120,7 @@ public class SteelPistonBaseBlock extends PistonBaseBlock{
         List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.getTemporaryBB((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
         for (Entity entity : entityList){
             if (entity == null || entity.noPhysics) continue;
-            final double speed = 2; // Todo design solution for making each stacked piston push less effective then the previous
+            final double speed = 2;
             entity.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
         }
         super.extendEvent(world, x, y, z, data, direction);
diff --git a/src/main/java/net/minecraft/core/data/registry/Registries.java b/src/main/java/net/minecraft/core/data/registry/Registries.java
index 9b061abca..98f563649 100644
--- a/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -71,7 +71,7 @@ public class Registries extends Registry<Registry<?>>
         ITEM_GROUPS.register("minecraft:planks",stackListOf(Blocks.PLANKS_OAK, new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 0), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 1), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 2), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 3), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 4), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 5), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 6), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 7), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 8), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 9), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 10), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 11), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 12), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 13), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 14), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 15)));
         ITEM_GROUPS.register("minecraft:grasses",stackListOf(Blocks.GRASS, Blocks.GRASS_RETRO));
         ITEM_GROUPS.register("minecraft:dirt",stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED));
-        ITEM_GROUPS.register("minecraft:trommel_dirt",stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED, Blocks.GRASS, Blocks.GRASS_RETRO, Blocks.GRASS_SCORCHED, Blocks.PATH_DIRT, Blocks.FARMLAND_DIRT));
+        ITEM_GROUPS.register("minecraft:trommel_dirt",stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED, Blocks.GRASS, Blocks.GRASS_RETRO, Blocks.GRASS_SCORCHED, Blocks.PATH_DIRT, Blocks.FARMLAND_DIRT, Blocks.MUD));
         ITEM_GROUPS.register("minecraft:moss_stones",stackListOf(Blocks.MOSS_STONE, Blocks.MOSS_BASALT, Blocks.MOSS_LIMESTONE, Blocks.MOSS_GRANITE));
         ITEM_GROUPS.register("minecraft:logs",stackListOf(Blocks.LOG_OAK, Blocks.LOG_PINE, Blocks.LOG_BIRCH, Blocks.LOG_CHERRY, Blocks.LOG_EUCALYPTUS, Blocks.LOG_OAK_MOSSY, Blocks.LOG_THORN, Blocks.LOG_PALM));
         ITEM_GROUPS.register("minecraft:leaves",stackListOf(Blocks.LEAVES_OAK, Blocks.LEAVES_OAK_RETRO, Blocks.LEAVES_PINE, Blocks.LEAVES_BIRCH, Blocks.LEAVES_CHERRY, Blocks.LEAVES_EUCALYPTUS, Blocks.LEAVES_SHRUB));
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index a12ce083f..09a8590b1 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -60,6 +60,7 @@ public abstract class Entity
     public float yRotO;
     public float xRotO;
     public float pushTime;
+    public int pushesThisTick;
     public final AABB bb = AABB.getPermanentBB(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
     public boolean onGround = false;
     public boolean horizontalCollision;
@@ -235,6 +236,7 @@ public abstract class Entity
 
     public void baseTick()
     {
+        pushesThisTick = 0;
         pushTime *= 0.98f;
         if (pushTime < 0.001f){
             pushTime = 0;
@@ -691,10 +693,12 @@ public abstract class Entity
     }
 
     public void fling(double xd, double yd, double zd, float pushTime) {
+        this.pushesThisTick++;
         this.fallDistance = 0;
-        this.xd += xd;
-        this.yd += yd;
-        this.zd += zd;
+        double scalar = Math.sqrt(pushesThisTick) - Math.sqrt(pushesThisTick - 1);
+        this.xd += xd * scalar;
+        this.yd += yd * scalar;
+        this.zd += zd * scalar;
         if (pushTime > this.pushTime) {
             this.pushTime = pushTime;
         }
@@ -1148,10 +1152,10 @@ public abstract class Entity
             float f = ((float)((i >> 0) % 2) - 0.5F) * bbWidth * 0.9F;
             float f1 = ((float)((i >> 1) % 2) - 0.5F) * 0.1F;
             float f2 = ((float)((i >> 2) % 2) - 0.5F) * bbWidth * 0.9F;
-            int j = MathHelper.floor(x + (double)f);
-            int k = MathHelper.floor(y + (double) getHeadHeight() + (double)f1);
-            int l = MathHelper.floor(z + (double)f2);
-            if(world.isBlockNormalCube(j, k, l))
+            int x = MathHelper.floor(this.x + (double)f);
+            int y = MathHelper.floor(this.y + (double) getHeadHeight() + (double)f1);
+            int z = MathHelper.floor(this.z + (double)f2);
+            if(world.isBlockNormalCube(x, y, z))
             {
                 return true;
             }
diff --git a/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java b/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
index 1374c94d8..e1912e1c6 100644
--- a/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
+++ b/src/main/java/net/minecraft/core/entity/FallingBlockEntity.java
@@ -9,37 +9,40 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.SandBlock;
 import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.BlockEntityDispatcher;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 public class FallingBlockEntity extends Entity
 {
-    public int blockID;
-    public int blockMeta;
-    public @Nullable BlockEntity blockEntity;
+    public CarriedBlock carriedBlock;
     public int fallTime;
     public boolean hasRemovedBlock = false;
 
     public FallingBlockEntity(World world)
     {
         super(world);
-        blockID = Blocks.SAND.id;
+        carriedBlock = new CarriedBlock(this, Blocks.SAND, 0, null);
         fallTime = 0;
     }
 
     public FallingBlockEntity(World world, double x, double y, double z, int blockId, int blockMeta, @Nullable BlockEntity blockEntity) {
         super(world);
         fallTime = 0;
-        this.blockID = blockId;
-        this.blockMeta = blockMeta;
-        this.blockEntity = blockEntity;
+        carriedBlock = new CarriedBlock(this, blockId, blockMeta, blockEntity);
+        if (blockEntity != null) {
+            blockEntity.worldObj = null;
+            blockEntity.carriedBlock = carriedBlock;
+        }
         blocksBuilding = true;
-        setSize(0.98F, 0.98F);
+        setSize(1F, 1F);
         heightOffset = bbHeight / 2.0F;
         setPos(x, y, z);
         xd = 0.0D;
@@ -70,7 +73,7 @@ public class FallingBlockEntity extends Entity
     @Override
 	public void tick()
     {
-        if(blockID == 0)
+        if(carriedBlock.blockId == 0)
         {
             remove();
             return;
@@ -79,7 +82,7 @@ public class FallingBlockEntity extends Entity
         if (pushTime < 0.05f || (pushTime < 0.25 && onGround)){
             pushTime = 0;
         }
-        if (isOnFire() && blockID == Blocks.TNT.id) {
+        if (isOnFire() && carriedBlock.blockId == Blocks.TNT.id) {
             remove();
             TNTPrimedEntity tntPrimedEntity = new TNTPrimedEntity(world, x, y, z);
             tntPrimedEntity.xd = this.xd;
@@ -92,7 +95,7 @@ public class FallingBlockEntity extends Entity
         xo = x;
         yo = y;
         zo = z;
-        if (pushTime < 0.05 && yd <= 0) {
+        if (pushTime < 0.01 && yd <= 0) {
             fallTime++;
         }
         yd -= 0.04D;
@@ -100,83 +103,96 @@ public class FallingBlockEntity extends Entity
         xd *= 0.98D;
         yd *= 0.98D;
         zd *= 0.98D;
-        int x = MathHelper.floor(this.x);
-        int y = MathHelper.floor(this.y);
-        int z = MathHelper.floor(this.z);
-        if(world.getBlockId(x, y, z) == blockID && !hasRemovedBlock)
+        int x = MathHelper.round(this.x - 0.5);
+        int y = MathHelper.round(this.y);
+        int z = MathHelper.round(this.z - 0.5);
+        if(world.getBlockId(x, y, z) == carriedBlock.blockId && !hasRemovedBlock)
         {
             world.setBlockWithNotify(x, y, z, 0);
             hasRemovedBlock = true;
         }
         if (onGround) {
+            Block selfBlock = carriedBlock.block();
             Block blockBelow = world.getBlock(x, y - 1, z);
-            double friction = blockBelow == null ? 0.98 : blockBelow.friction * 0.91F;
+            double friction = selfBlock.friction;
+            friction *= blockBelow == null ? 0.98 : blockBelow.friction * 0.91f;
             xd *= friction;
             zd *= friction;
             yd *= -0.5D;
             pushTime *= (float) friction;
         }
-        if (pushTime < 0.05) {
-            if(onGround)
+
+        double v = Math.hypot(xd, zd);
+        if (v < 0.001 || isInWall()) {
+            if(onGround || isInWall())
             {
+                Entity rider = getPassenger();
+                ejectRider();
                 remove();
-                if((!world.canBlockBePlacedAt(blockID, x, y, z, true, Side.TOP) || SandBlock.canFallBelow(world, x, y - 1, z) || !world.setBlock(x, y, z, blockID)) && !world.isClientSide)
+                if((!world.canBlockBePlacedAt(carriedBlock.blockId, x, y, z, true, Side.TOP) || SandBlock.canFallBelow(world, x, y - 1, z) || !world.setBlock(x, y, z, carriedBlock.blockId)) && !world.isClientSide)
                 {
                     if(hasRemovedBlock) {
                         drop();
                     }
                 } else if (!world.isClientSide) {
-                    world.setBlockMetadata(x, y, z, blockMeta);
-                    world.notifyBlockChange(x, y, z, blockID);
-                    if (blockEntity != null) {
+                    world.setBlockMetadata(x, y, z, carriedBlock.metadata);
+                    if (carriedBlock.entity != null) {
                         BlockEntity oldEnt = world.getBlockEntity(x, y, z);
                         if (oldEnt != null) {
                             oldEnt.invalidate();
                         }
-                        blockEntity.validate();
-                        blockEntity.x = x;
-                        blockEntity.y = y;
-                        blockEntity.z = z;
-                        world.replaceBlockTileEntity(x, y, z, blockEntity);
+                        carriedBlock.entity.validate();
+                        carriedBlock.entity.x = x;
+                        carriedBlock.entity.y = y;
+                        carriedBlock.entity.z = z;
+                        carriedBlock.entity.worldObj = world;
+                        carriedBlock.entity.carriedBlock = null;
+                        world.replaceBlockTileEntity(x, y, z, carriedBlock.entity);
                     }
+                    world.notifyBlockChange(x, y, z, carriedBlock.blockId);
                 }
-            } else
-            if(fallTime > 100 && !world.isClientSide)
-            {
+                if (rider != null) {
+                    BlockEntity te = world.getBlockEntity(x, y, z);
+                    if (te instanceof IVehicle) rider.startRiding((IVehicle) te);
+                }
+            } else if(fallTime > 600 && !world.isClientSide) {
                 if(hasRemovedBlock) {
                     drop();
                 }
+                ejectRider();
                 remove();
             }
+
+            carriedBlock.heldTick(world, this);
         }
     }
 
     public void drop() {
-        Block block = Block.getBlock(blockID);
+        Block block = carriedBlock.block();
         if (block != null) {
-            ItemStack[] drops = block.getBreakResult(world, EnumDropCause.WORLD, blockMeta, blockEntity);
+            ItemStack[] drops = block.getBreakResult(world, EnumDropCause.SILK_TOUCH, carriedBlock.metadata, carriedBlock.entity);
             if (drops != null && drops.length > 0) {
                 for (int i = 0; i < drops.length; i++) {
                     spawnAtLocation(drops[i], 0);
                 }
             }
         }
-        if (blockEntity != null) {
-            int x = MathHelper.floor(this.x);
-            int y = MathHelper.floor(this.y);
-            int z = MathHelper.floor(this.z);
-            blockEntity.dropContents(world, x, y, z);
+        if (carriedBlock.entity != null) {
+            int x = MathHelper.round(this.x - 0.5);
+            int y = MathHelper.round(this.y);
+            int z = MathHelper.round(this.z - 0.5);
+            carriedBlock.entity.dropContents(world, x, y, z);
         }
     }
 
     @Override
     public void addAdditionalSaveData(CompoundTag tag)
     {
-        tag.putShort("Tile", (short)blockID);
-        tag.putShort("TileData", (short) blockMeta);
-        if (blockEntity != null) {
+        tag.putShort("Tile", (short)carriedBlock.blockId);
+        tag.putShort("TileData", (short) carriedBlock.metadata);
+        if (carriedBlock.entity != null) {
             CompoundTag entityTag = new CompoundTag();
-            blockEntity.writeToNBT(entityTag);
+            carriedBlock.entity.writeToNBT(entityTag);
             tag.putCompound("TileEntity", entityTag);
         }
     }
@@ -184,11 +200,10 @@ public class FallingBlockEntity extends Entity
     @Override
 	public void readAdditionalSaveData(CompoundTag tag)
     {
-        blockID = tag.getShort("Tile") & 0x3fff;
-        blockMeta = tag.getShort("TileData") & 0xff;
-        if (tag.containsKey("TileEntity")) {
-            blockEntity = BlockEntity.createAndLoadEntity(tag.getCompound("TileEntity"));
-        }
+        carriedBlock = new CarriedBlock(this,
+            tag.getShort("Tile") & 0x3fff,
+            tag.getShort("TileData") & 0xff,
+            tag.containsKey("TileEntity") ? BlockEntityDispatcher.createAndLoadEntity(tag.getCompound("TileEntity")) : null);
     }
 
     @Override
@@ -203,13 +218,13 @@ public class FallingBlockEntity extends Entity
         return 0.0F;
     }
 
-    public World getWorld()
-    {
-        return world;
-    }
-
     @Override
     public boolean showBoundingBoxOnHover() {
         return true;
     }
+
+    @Override
+    public double getRideHeight() {
+        return 0.0D;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 728d6f1c1..2d7f1a860 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.logic.RailDirection;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
@@ -702,12 +703,12 @@ public class MinecartEntity extends Entity implements Container {
 	public boolean interact(Player player) {
         switch (type){
             case PASSENGER_CART:
-                if (!world.isClientSide && passenger == null && player.isSneaking() && player.getHeldObject() instanceof BlockEntity.CarriedBlock) {
-                    BlockEntity.CarriedBlock carriedBlock = (BlockEntity.CarriedBlock) player.getHeldObject();
+                if (!world.isClientSide && passenger == null && player.isSneaking() && player.getHeldObject() instanceof CarriedBlock) {
+                    CarriedBlock carriedBlock = (CarriedBlock) player.getHeldObject();
                     if (carriedBlock.entity instanceof ChestBlockEntity) {
                         ChestBlockEntity chest = (ChestBlockEntity) carriedBlock.entity;
                         this.type = CHEST_CART;
-                        if (carriedBlock.block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
+                        if (carriedBlock.blockId == Blocks.CHEST_PLANKS_OAK_PAINTED.id) {
                             this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR | TYPE_MASK_PAINTED_CHEST;
                         } else {
                             this.typeMeta = carriedBlock.metadata & TYPE_MASK_COLOR;
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java
index 69d474871..907a78e46 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/FallingSandNetEntry.java
@@ -45,6 +45,6 @@ public class FallingSandNetEntry implements IVehicleEntry<FallingBlockEntity>, I
 
     @Override
     public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FallingBlockEntity trackedObject) {
-        return new AddEntityPacket(trackedObject, trackedObject.blockID);
+        return new AddEntityPacket(trackedObject, trackedObject.carriedBlock.blockId);
     }
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
index 9041c2412..e296a1fae 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
@@ -80,7 +80,9 @@ public class CraftingMenu extends AbstractContainerMenu
 				storeOrDropItem(player, itemstack);
 				insert = true;
 			}
+			craftSlots.setItem(i, null);
 		}
+		resultSlots.setItem(0, null);
 		if(insert) {
 			player.world.playSoundAtEntity(null, player, "random.insert", 0.1F, 1.0f);
 		}
diff --git a/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 99db8f0f1..5dfdac277 100644
--- a/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -40,6 +40,11 @@ public class MathHelper
         return d >= (double)truncated ? truncated : truncated - 1;
     }
 
+    public static int round(double d) {
+        int truncated = (int) d;
+        return d <= truncated + 0.5 ? truncated : truncated + 1;
+    }
+
     public static float abs(float f)
     {
         return f < 0.0F ? -f : f;
diff --git a/src/main/java/net/minecraft/core/world/ICarriable.java b/src/main/java/net/minecraft/core/world/ICarriable.java
index f8d6873ba..44a8f4db6 100644
--- a/src/main/java/net/minecraft/core/world/ICarriable.java
+++ b/src/main/java/net/minecraft/core/world/ICarriable.java
@@ -2,7 +2,7 @@ package net.minecraft.core.world;
 
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.Side;
 import org.slf4j.Logger;
@@ -39,10 +39,12 @@ public interface ICarriable {
 
     void readFromNBT(CompoundTag tag);
 
+    String TYPE_BLOCK = "block";
+
     static ICarriable createAndLoadCarriable(Entity holder, CompoundTag tag) {
         String type = tag.getString("type");
-        if (type.equalsIgnoreCase("blockEntity")) {
-            return BlockEntity.CarriedBlock.createAndLoadCarriedBlock(holder, tag);
+        if (type.equalsIgnoreCase(TYPE_BLOCK)) {
+            return CarriedBlock.createAndLoadCarriedBlock(holder, tag);
         }
         LOGGER.warn("Could not identify carriable for type {}!", type);
         return null;
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 41b6334c4..ca34189d2 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
+import net.minecraft.core.block.entity.BlockEntityDispatcher;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import com.mojang.nbt.Tag;
@@ -303,7 +304,7 @@ public class ChunkLoaderLegacy
                 if (tileEntityTagBase instanceof CompoundTag)
                 {
                     CompoundTag tileEntityTag = (CompoundTag) tileEntityTagBase;
-                    BlockEntity blockEntity = BlockEntity.createAndLoadEntity(tileEntityTag);
+                    BlockEntity blockEntity = BlockEntityDispatcher.createAndLoadEntity(tileEntityTag);
                     if (blockEntity != null)
                     {
                         chunk.addBlockEntity(blockEntity);
